#
# Maailman turhin ohjelma (C) 2001 by Sami Kystil
#

import wave
import math
import font
import sys

def test(cond,t,f):
        if cond: return t
        else: return f

def function(freq):
        return lambda t,f=freq: math.sin(f*t)

def write(file,form,length,steps):
        for i in range(0,length):
                t=float(i)/float(length) * math.pi*2
                sum=0.0
                n=0
                for i in range(0,steps-1):
                        sum+=form[i](t)
                        n+=1
                file.writeframesraw(chr((sum/test(n>0,n,1))*127+128))

def transform(string,filename):
        scale=8
        min=1*scale
        max=16*scale
        steps=8
        length=256*8
        pause=length/2
        display=0

        silence=function(0)
        freq=[]
        form=[silence,silence,silence,silence,silence,silence,silence,silence]
        mute=[silence,silence,silence,silence,silence,silence,silence,silence]
        for i in range(0,steps-1):
                freq.append(function(max-((max-min)/steps)*i))

        f=wave.open(filename,"w")
        f.setnchannels(1)
        f.setsampwidth(1)
        f.setframerate(11025)

        sys.stdout.write("."*len(string)+"\r")
        for c in string:
                sys.stdout.write(c)
                write(f,mute,pause,steps)
                for row in range(0,7):
                        mask=font.font[ord(c)*8+row]

                        if display:
                                print("%s%s%s%s%s%s%s%s" % (
                                        test(mask&0x80,"#"," "),
                                        test(mask&0x40,"#"," "),
                                        test(mask&0x20,"#"," "),
                                        test(mask&0x10,"#"," "),
                                        test(mask&0x8, "#"," "),
                                        test(mask&0x4, "#"," "),
                                        test(mask&0x2, "#"," "),
                                        test(mask&0x1, "#"," ")))

                        for i in range(0,steps-1):
                                if mask&1<<i:
                                        form[i]=freq[i]
                                else:
                                        form[i]=silence
                        write(f,form,length,steps)

        f.close()

        

if __name__=="__main__":
        transform(" Hello, World! ","hello.wav")
        
